from yby.y_control import y_start
y_start()


#############################################################################

def y_entropy(*l_prob):
    
    '''
    计算一组和为1的概率的熵
    l_prob: 一组和为1的概率值，输入形式可以是多参数、元组、列表
    result: 熵的值
    '''
    
    import numpy as np
    
    result = 0
    sum_p = 0
    for i in l_prob:
        current = - i * np.log2(i)
        result = result + current
        sum_p += i
    assert sum_p - 1 <= np.power(10.0, -6), 'sum(probability) !=1'
    
    return result

#############################################################################

def y_gini(a, b):
    
    '''
    计算gini系数
    a, b: 只有两个位置参数，分别代表两类事件的个数
    result: gini系数值
    '''

    import numpy as np
    
    sum1 = a + b
    result = 1 - np.power(a / sum1, 2) - np.power(b / sum1, 2)
    assert isinstance(a, int)
    assert isinstance(b, int)
    
    return result

##############################################################################

