from yby.y_control import y_start
y_start()


###############################################################################

def y_hotpath():
    '''
    Get hot path, 0 for input.
    '''
    
    from yby.y_control import y_display
    
    src_common = [r'D:\颜昺阳',
                 r'D:\颜昺阳\3. 事件日志',
                 r'D:\颜昺阳\4. 科研项目',
                 r'D:\颜昺阳\4. 科研项目\2020-颜昺阳-Python\yby']
    
    dst_common = [r'G:\颜昺阳',
                 r'G:\颜昺阳\3. 事件日志',
                 r'G:\颜昺阳\4. 科研项目',
                 r'C:\Software\Python\Lib\site-packages\yby']
    
    y_display('Choose src path:')
    for i in range(len(src_common)):
        print(str(i+1) + ' : ' + src_common[i])
    i = input('Input:')
    if i!='0':
        src = src_common[int(i)-1]
    else:
        src = input('Please input src path: ')
    
    y_display('Choose dst path:')
    for i in range(len(dst_common)):
        print(str(i+1) + ' : ' + dst_common[i])
    j = input('Input:')
    if j!='0':
        dst = dst_common[int(j)-1]
    else:
        dst = input('Please input dst path: ')
    
    return src, dst

###############################################################################

def y_append(file,string,position='end'):
    
    '''
    Add string to file.
    
    PARAMETERS:
    -----------
    file       - file abspath
    string    - adding string
    position   - default is 'end', opetional:['start', 'end']
    '''
    
    import os
    
    
    with open(file, 'r+', encoding='UTF-8') as fp:
        content = fp.read()
        if position=='start':
            fp.seek(0,0)
            fp.write(string + content)
        else:
            fp.seek(0,2)
            fp.write(string)
    
    print('Successfully!')


##############################################################################

def y_replace(file, old, new, max_num=1000):
    '''
    replace old str with new str in file, changeable max_num=1000
    
    PARAMETERS:
    -----------
    file         - file path
    old          - old string
    new          - new string
    max_num      - default is 1000, maximun replace times
    '''
    
    tem = []
    with open(file, 'r+', encoding='utf-8') as fp:
        contents = fp.read()

    new_contents = contents.replace(old, new, max_num)

    with open(file, 'w+', encoding='utf-8') as fp:
        fp.write(new_contents)

##############################################################################

def y_sync():
    
    '''
    Sync src files to dst files in mirror mode. 
    '''
    
    import os
    import shutil
    from yby.y_control import y_display

    ## 记录基础信息
    def info(path):

        roots = []
        dirs = []
        files = []
        for r,d,f in os.walk(path):
            roots.append(r)
            dirs.append(d)
            files.append(f)

        all_dirs = []
        all_files = []
        for r,d,f in os.walk(path):
            for i in d:
                all_dirs.append(os.path.join(r,i))
            for j in f:
                all_files.append(os.path.join(r,j))

        d = {}
        d['roots'] = roots
        d['dirs'] = dirs
        d['files'] = files
        d['all_dirs'] = all_dirs
        d['all_files'] = all_files

        return d            

    ## 删除目标文件夹中  比源文件夹中  多出的文件夹 和 多出的文件
    def delete(src_info, dst_info, k='dirs'):

        the_list = []
        for i in dst_info[k]:
            idx = dst_info[k].index(i)
            for ii in i:
                try:
                    if ii not in src_info[k][idx]:
                        pass
                except:
                    dst_path = os.path.join(dst_info['roots'][idx],ii)
                    if os.path.exists(dst_path):
                            the_list.append(dst_path)
                            rec_path = dst_path.replace(dst,r_path)
                            if k=='dirs':
                                shutil.move(dst_path, rec_path)
                            if k=='files':
                                if not os.path.exists(os.path.dirname(rec_path)):
                                    os.makedirs(os.path.dirname(rec_path))
                                    shutil.move(dst_path, rec_path)
                else:
                    if ii not in src_info[k][idx]:
                        dst_path = os.path.join(dst_info['roots'][idx],ii)
                        if os.path.exists(dst_path):
                            the_list.append(dst_path)
                            rec_path = dst_path.replace(dst,r_path)
                            if k=='dirs':
                                shutil.move(dst_path, rec_path)
                            if k=='files':
                                if not os.path.exists(os.path.dirname(rec_path)):
                                    os.makedirs(os.path.dirname(rec_path))
                                    shutil.move(dst_path, rec_path)


        return the_list

    ## 在目标文件夹中 创建文件夹：源文件夹中比目标文件夹中多出的文件夹
    def copy(src_info, dst_info):

        the_list = []
        src_half_files = []
        dst_half_files = []
        for i in src_info['all_files']:
            i = i.replace(src, '')
            src_half_files.append(i)
        for i in dst_info['all_files']:
            i = i.replace(dst, '')
            dst_half_files.append(i)

        for i in src_half_files:
            if i not in dst_half_files:
                if i[0]=='\\' or i[0]=='/':
                    i = i[1:]
                the_list.append(os.path.join(src,i))
                if not os.path.exists(os.path.dirname(os.path.join(dst, i))):
                    os.makedirs(os.path.dirname(os.path.join(dst, i)))
                shutil.copy(os.path.join(src, i), os.path.join(dst, i))

        return the_list

    ## 更新修改时间不同的文件
    def update(src_info, dst_info):

        the_list=[]
        src_half_files = []
        dst_half_files = []
        for i in src_info['all_files']:
            i = i.replace(src, '')
            src_half_files.append(i)
        for i in dst_info['all_files']:
            i = i.replace(dst, '')
            dst_half_files.append(i)

        for i in dst_half_files:
            if i[0]=='\\' or i[0]=='/':
                i = i[1:]
            if os.path.getsize(os.path.join(dst, i))!=os.path.getsize(os.path.join(src, i)):
                the_list.append(os.path.join(src, i))
                
                rec_path = os.path.join(r_path, i)
                if not os.path.exists(os.path.dirname(rec_path)):
                    os.makedirs(os.path.dirname(rec_path))
                    shutil.copy(os.path.join(dst, i), rec_path)
                
                shutil.copy(os.path.join(src, i), os.path.join(dst, i))

        return the_list
         

    src, dst = y_hotpath()

    y_display('','Please input y to sync files!')
    i = input('Input:')

    if i=='y':
        src_info = info(src)
        dst_info = info(dst)
        text1 = 'There are {:.0f} folder and {:.0f} files in src!\n'.format(len(src_info['roots']), len(src_info['all_files']))
        text2 = 'There are {:.0f} folder and {:.0f} files in dst!\n'.format(len(dst_info['roots']), len(dst_info['all_files']))
        y_display('Information', text1+text2)


        ## 创建回收站
        r_path = os.path.join(os.path.split(dst)[0],'Recycle')
        if os.path.exists(r_path):
            shutil.rmtree(r_path)
        else:
            os.mkdir(r_path)

        del_dirs = delete(src_info, dst_info, k='dirs')
        y_display('Deleting folders...', '{:.0f} folders have been deleted!'.format(len(del_dirs)))
        for i in del_dirs:
            print(i)


        src_info = info(src)
        dst_info = info(dst)
        del_files = delete(src_info, dst_info, k='files')
        y_display('Deleting files...', '{:.0f} files have been deleted!'.format(len(del_files)))
        for i in del_files:
            print(i)

        src_info = info(src)
        dst_info = info(dst)
        copy_files = copy(src_info, dst_info)
        y_display('Copying files from src to dst!', '{:.0f} files have been copied!'.format(len(copy_files)))
        for i in copy_files:
            print(i)

        src_info = info(src)
        dst_info = info(dst)
        assert len(src_info['all_files'])==len(dst_info['all_files']), "yby: Files number is different between src({:.0f}) and dst({:.0f})!".format(len(src_info['all_files']),len(dst_info['all_files']))
        update_files = update(src_info, dst_info)
        y_display('Updating files from src to dst!', '{:.0f} files have been updated!'.format(len(update_files)))
        for i in update_files:
            print(i)
    
##############################################################################

    
